//------------------------------------------------------------------------
//aviutlvOC pwcubic
// Copyright (c) 2008  N099
//------------------------------------------------------------------------
#include <windows.h>
#include <malloc.h>
#include <xmmintrin.h>

#include "filter.h"
#include "cubic.h"

//------------------------------------------------------------------------
// \[XǗp
//------------------------------------------------------------------------
typedef struct _work_mem {
    void   *p; //̃obt@
    size_t ww;
    int hs,ws;
    __m128 *temp;
} work_mem;

static work_mem w_mem = { NULL, };
static p_weight p_w;

//Xbh̍ő吔
#define THREAD_MAX 16 
#define ALIGN(a,b) (((a)+((b)-1))&~((b)-1))

static BOOL mt_exec_dummy(MULTI_THREAD_FUNC fn, void *p1, void *p2);
static void mt_proc_h(int id, int num, void *para1, void *para2);
static void mt_proc_v(int id, int num, void *para1, void *para2);
static int alloc_wmem(work_mem *wm, int h, int w);
static int is_sse_available(void);

//------------------------------------------------------------------------
//tB^\̒`
//------------------------------------------------------------------------
#define TRACK_N 4
TCHAR *track_name[]   = {"X", "Y", "B", "C", "type" };
int   track_default[] = { 640, 480, 0, 64, 0 };
int   track_s[] = {   32,   32, -256, -256, 0 };
int   track_e[] = { 2048, 2048,  256,  256, 3 };
enum  { T_X, T_Y, T_B, T_C, T_TYPE };

#define CHECK_N 1
LPSTR check_name[] = { "c = (1-b)/2" };
int check_default[] = { 0 };

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION, 0,0,
    "L[rbN",
    TRACK_N, track_name, track_default, track_s, track_e,
    CHECK_N, check_name, check_default,
    func_proc,
    func_init,
    func_exit,
    NULL,
    func_WndProc,
    NULL, NULL, NULL, 0,
    "pwcubic by N099, ver0.6",
    NULL, NULL,

};

//------------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//------------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    //SSEK{
    if(!is_sse_available()){
        filter.func_proc = NULL;
    }
    return &filter;
}

//------------------------------------------------------------------------
// ɌĂ΂֐
//------------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
    //őTCY擾
    SYS_INFO si = {0};
    if(!fp->exfunc->get_sys_info(NULL, &si)){
        return FALSE;
    }else{
        track_s[0] = si.min_w;
        track_s[1] = si.min_h;
        track_e[0] = si.max_w;
        track_e[1] = si.max_h;
        fp->exfunc->filter_window_update(fp);
    }
    
    return TRUE;
}

//------------------------------------------------------------------------
// IɌĂ΂֐
//------------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
    if(w_mem.p != NULL){
        VirtualFree(w_mem.p, 0, MEM_RELEASE);
        ZeroMemory(&w_mem, sizeof(w_mem));
    }

    return TRUE;
}

//------------------------------------------------------------------------
// tB^֐
//------------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
    BOOL (*exec_mt)(MULTI_THREAD_FUNC, void*, void*) = NULL;
    RECT rsize;
    int c;

    _mm_empty();

    //Ɨ̈̊m
    if(alloc_wmem(&w_mem, fpip->max_h, fpip->max_w)){
        return FALSE;
    }

    //TCY̐ݒ
    rsize.left   = fpip->w; 
    rsize.top    = fpip->h;
    rsize.right  = fp->track[T_X];
    rsize.bottom = fp->track[T_Y];

    //d݂̐ݒ
    if(fp->check[0]){
        c = (128 - fp->track[T_B]  + 1)/2;
    }else{
        c = fp->track[T_C];
    }
    cb_set_weight(&p_w, 0, fp->track[T_B], c);

    //}`Xbh֐płꍇg
    exec_mt = fp->exfunc->exec_multi_thread_func;
    if(exec_mt == NULL) exec_mt = mt_exec_dummy;

    //->̏ŏ
    if(fp->track[T_X] != fpip->w){
        //̃TCY
        if(!exec_mt(mt_proc_h, fpip->ycp_edit, &rsize)){
            return FALSE;
        }
        fpip->w = fp->track[T_X];
    }
    if(fp->track[T_Y] != fpip->h){
        //̃TCY
        if(!exec_mt(mt_proc_v, fpip->ycp_edit, &rsize)){
            return FALSE;
        }
        fpip->h = fp->track[T_Y];
    }

    return TRUE;
}

//------------------------------------------------------------------------
// }`Xbh֐
//------------------------------------------------------------------------
BOOL mt_exec_dummy(MULTI_THREAD_FUNC fn, void *p1, void *p2)
{
    fn(0, 1, p1, p2);
    return TRUE;
}

void mt_proc_h(int id, int num, void *para1, void *para2)
{
    PIXEL_YC *pyc = para1;
    __m128 *px = w_mem.temp + id * w_mem.ww;
    RECT *rsize = (RECT*)para2;
    int i,c,n;
    unsigned int csr;
#if 0
    volatile void *dummy = _alloca(id * 128); //for HTT
#endif
    
    //z肷őXbh𒴂
    num = num>THREAD_MAX ? THREAD_MAX : num;
    if(id >= THREAD_MAX) return;
    
    //flush to zero mode LiXbhƁj
    csr = _mm_getcsr();
    _mm_setcsr(_MM_MASK_MASK|_MM_FLUSH_ZERO_MASK);

    //摜𐔃CƂɕ
    c = (rsize->top + num - 1)/num;
    n = c * (id + 1);
    i = c * id;
    n = (n > rsize->top) ? rsize->top : n;

    for( ; i<n; ++i){
        c = w_mem.ws * i;
        cb_cnv_h_yc(pyc+c, px, rsize->left);
        cb_hresize_yc(pyc+c, px, &p_w, rsize->left, rsize->right);
    }

    _mm_setcsr(csr);
    _mm_empty();
}

void mt_proc_v(int id, int num, void *para1, void *para2)
{
    __m64  *pyc = para1;
    __m128 *px = w_mem.temp + id * w_mem.ww;
    RECT *rsize = (RECT*)para2;
    int i,c,n,mw,ms;
    unsigned int csr;
#if 0
    volatile void *dummy = _alloca(id * 128); //for HTT
#endif

    //z肷őXbh𒴂
    num = num>THREAD_MAX ? THREAD_MAX : num;
    if(id >= THREAD_MAX) return;
    
    //flush to zero mode LiXbhƁj
    csr = _mm_getcsr();
    _mm_setcsr(_MM_MASK_MASK|_MM_FLUSH_ZERO_MASK);

    //64bitPʂɊZ
    ms = (w_mem.ws * sizeof(PIXEL_YC))/sizeof(__m64); //؂O
    mw = (rsize->right * sizeof(PIXEL_YC)) + (sizeof(__m64) - 1);
    mw /= sizeof(__m64);
    
    //摜𐂒ŕi{̓LbVCTCYlƂj
    c = (mw + num - 1)/num;
    n = c * (id + 1);
    i = c * id;
    n = (n > mw) ? mw : n;
    
    for( ; i<n; ++i){
        cb_cnv_v_yc(pyc+i, px, rsize->top, ms);
        cb_vresize_yc(pyc+i, px, &p_w, rsize->top, rsize->bottom, ms);
    }

    _mm_setcsr(csr);
    _mm_empty();
}

//------------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//------------------------------------------------------------------------
BOOL func_WndProc(HWND hwnd, UINT message, WPARAM wparam,
                  LPARAM lparam, void *editp, FILTER *fp)
{
    switch(message){
    case WM_FILTER_CHANGE_ACTIVE:
        if(!fp->exfunc->is_filter_active(fp)){
            //\[XJ
            func_exit(NULL);
        }
        break;
    default:
        break;
    }

    return FALSE;
}

//------------------------------------------------------------------------
// ̈m
//------------------------------------------------------------------------
int alloc_wmem(work_mem *wm, int h, int w)
{
    size_t sz,sz_w;
    
    // őTCY͕ωȂ͂Ȃ̂ňxmۂOK
    if(wm->p){
        return 0;
    }

    // ŜAP[giw4̔{łOj
    sz_w = h>w ? h : w;
    sz_w = ALIGN((unsigned int)(sz_w + 2*2 + 1), 8); //[:2*2,K[h:1
    sz = (sz_w * THREAD_MAX) * sizeof(__m128);
    wm->p = VirtualAlloc(NULL, sz, MEM_COMMIT, PAGE_READWRITE);
    if(NULL == wm->p){
        return -1;
    }

    // eobt@ʒuvZ
    wm->temp = (__m128*)wm->p;

    wm->hs = h;
    wm->ws = w;
    wm->ww = sz_w;
    
    return 0;
}

//------------------------------------------------------------------------
// SSEɑΉĂ邩`FbN
//------------------------------------------------------------------------
int is_sse_available(void)
{
    long r_ecx,r_edx;

    // CPUIDɂ`FbN
    __asm {
        mov eax, 1
        cpuid
        mov r_edx, edx
        mov r_ecx, ecx
    }

    // MMX  0x0800000 edx
    // SSE  0x2000000 edx
    // SSE2 0x4000000 edx
    // SSE3 0x0000001 ecx
    r_edx &= 0x6800000;
    r_ecx &= 0x0000001;

    if(r_edx < 0x1000000)
        return 0;

    // OST|[gĂ邩
    __try {
        __asm xorps xmm0, xmm0
    }

    __except(EXCEPTION_EXECUTE_HANDLER){
        if(_exception_code()==STATUS_ILLEGAL_INSTRUCTION)
            return 0;
    }
    
    return 1;
}

